#Include "FiveWin.Ch"
#Include "SSay.Ch"         // SAY'S Transparentes
#Include "Obj2Hb.Ch"

#Define CLR_AMARELO   nRGB( 255, 255, 000 ) //--> Amarelo Para o Fundo

Function Calend()

    LOCAL oFont, oFont2, oFonte, oFont3, oSay,  oBrush
    LOCAL oDlg, nVar2, oPrueba1
    LOCAL oPrueba, oBtn[ 10], oCombo[ 2 ]
    LOCAL nVar1 := nVar2 := 1
    LOCAL aLenguajes := { "  Portugus ", ;
                          "  Catalo   ", ;
                          "  Euskera   ", ;
                          "  Galego    ", ;
                          "  Espanhol  ", ;
                          "  Italiano  ", ;
                          "  Ingls    ", ;
                          "  Francs   ", ;
                          "  Alemo    " }

     LOCAL aCombinacion:={ "  Cores 1"   , ;
                           "  Cores 2"   , ;
                           "  Cores 3"   , ;
                           "  Cores 4"   , ;
                           "  Cores 5"   , ;
                           "  Cores 6"  }

    LOCAL aTit_Color := aComboTitulo()
    LOCAL aCue_Color := aComboCuerpo()
    LOCAL aDom_Color := aComboDomingo()

    LOCAL aClrFestivo := { Rgb( 255, 255, 255),;   //Color borde superior
                           Rgb( 255, 255,   0),;   //Color relleno
                           Rgb( 180, 180,   0),;   //Color borde inferior
                           Rgb(   0,   0,   0) }   //color texto....

    LOCAL aColorCuerpo := {Rgb( 154, 242, 250),;  //Color borde superior
                           Rgb(  11, 196, 210),;  //Color relleno
                           Rgb(   9, 138, 149),;  //Color borde inferior
                           Rgb(   0,   0,   0),;  //color texto....
                           Rgb(   9, 138, 149) }  //color al perder el foco...

    LOCAL aColorTitulo := {Rgb(  10, 165, 177),;  // Color Borde superior
                           Rgb(   0, 128, 128),;  // Color de Relleno
                           Rgb(   5,  82,  88),;  // Color Borde inferior
                           Rgb( 205, 205, 155),;  // Color Letra mes y ao
                           Rgb( 205, 205, 155) }  // Color de los dias.

    LOCAL aColorBoton  := {Rgb(  10, 165, 177),;  // Color Borde superior
                           Rgb(   0, 128, 128),;  // Color de Relleno
                           Rgb(   5,  82,  88),;  // Color Borde inferior
                           Rgb( 205, 205, 155),;  // Color Letra mes y ao
                           Rgb( 205, 205, 155) }  // Color de los dias.

    //-> Dialogo
    DEFINE BRUSH oBrush    RESOURCE "LOGO2" //-> PEGA A BITMAP DO ARQUIVO.RES(LOGO.BMP)

    // Se activa el archivo de recursos a utilizar.
    DEFINE FONT oFont  NAME "Arial"         SIZE 0,-14 BOLD
    DEFINE FONT oFont3 NAME "Ms Sans Serif" SIZE 0,-13 BOLD

    DEFINE DIALOG oDlg TITLE "Calendrio do Sistema For Windows " ;
           FROM 10,10 TO 360, 420 PIXEL COLOR "N/W"               ;
           STYLE nOR( DS_MODALFRAME )                             ;
           BRUSH oBrush TRANSPARENT

    oDlg:nStyle := nOr( oDlg:nStyle, 4 )

    oDlg:lHelpIcon := .F.

    oPrueba1:= TMiCalendario(): New ( 5, 5, 120, 120, oDlg, oFont)

    oPrueba1:bLButtonUp := {|| MsgInfo( oPrueba1:aFecha[2], ;
                                        "Data Selecionada Pelo Usurio" ) }

    // Para pintar los domingos de otro color...
    oPrueba1:FijaClrDomingo( {Rgb( 255, 255, 255),;   //Color borde superior
                              Rgb( 220, 220, 220),;   //Color relleno
                              Rgb( 128, 128, 128),;   //Color borde inferior
                              Rgb(   0,   0,   0) } ) //color texto....

    // Aqui tem um Erro, Que No Consegui Descobrir.
    // Para pintar los dias festivos..

    oPrueba1:aFestivos[ 1] := {1}      //Festivos de Enero
    oPrueba1:aFestivos[ 2] := {}       //Festivos de Ferbrero
    oPrueba1:aFestivos[ 3] := {}       //Festivos de Marzo
    oPrueba1:aFestivos[ 4] := {18,19}  //Festivos de Abril
    oPrueba1:aFestivos[ 5] := {1,21}   //Festivos de Mayo
    oPrueba1:aFestivos[ 6] := {16}     //Festivos de Junio
    oPrueba1:aFestivos[ 7] := {}       //Festivos de Julio
    oPrueba1:aFestivos[ 8] := {15}     //Festivos de Agosto
    oPrueba1:aFestivos[ 9] := {18,19}  //Festivos de Septiembre
    oPrueba1:aFestivos[10] := {}       //Festivos de Octubre
    oPrueba1:aFestivos[11] := {1}      //Festivos de Noviembre
    oPrueba1:aFestivos[12] := {25}     //Festivos de Diciembre
    oPrueba1:aColorFestivo := aClrFestivo
    oPrueba1:FijaClrFestivo()

    // Al cambiar de mes... se asignan nuevos festivos...
    // Este es un metodo alternativo de marcar los festivos..
    oPrueba1:bCambioMes := { || FijarFestivos( oPrueba1 ) }
            
    @   5,140 COMBOBOX oCombo[ 1 ] VAR nVar1 ;
              ITEMS aLenguajes OF oDlg       ;
              SIZE  50,150                   ;
              FONT oFont3                    ;
              PIXEL                          ;
              ON CHANGE ( oPrueba1:nLanguage := nVar1, ;
                          oPrueba1:Language(),         ;
                          oPrueba1:Paint() )

    @  20,140 COMBOBOX oCombo[ 1 ] VAR nVar2 ;
              ITEMS aCombinacion OF oDlg     ;
              SIZE  50,150                   ;
              FONT oFont3                    ;
              PIXEL                          ;
              ON CHANGE ( oPrueba1:aColorTitulo := aTit_Color[ nVar2],  ;
                          oPrueba1:aColorCuerpo := aCue_Color[ nVar2],  ;
                          oPrueba1:aColorBoton  := aTit_Color[ nVar2],  ;
                          oPrueba1:FijaClrDomingo( aDom_Color[ nVar2]), ;
                          oPrueba1:RestaurarColor(),                    ;
                          oPrueba1:Paint() )

    @ 145,010 SENSITIVE SAY oSay PROMPT "<ESC> Sair "     ;
              OF oDlg PIXEL SIZE 60,12                    ;
              COLOR CLR_BLACK UPDATE FONT oFont  TRANSPARENT

    @  35,140 BUTTON oBtn[  1]  PROMPT "&Display    "   ;
              OF oDlg PIXEL SIZE 50,12                  ;
              FONT oFont                                ;
              ACTION( MsgInfo( oPrueba1:aFecha[2],      ;
                      "Data Selecionada Pelo Usurio" ) )

    oBtn[  1]:cToolTip := ( "Data Selecionada Pelo Usurio" )

    @  50,140 BUTTON oBtn[  2] PROMPT "31/12/2008   "   ;
              OF oDlg PIXEL SIZE 50,12                  ;
              FONT oFont                                ;
              ACTION oPrueba1:IrFecha( CtoD("31/12/2008") )

    oBtn[  2]:cToolTip := ( "Data Selecionada Pelo Usurio: 31/12/2008" )

    @  65,140 BUTTON oBtn[  3] PROMPT "&Hoje         "  ;
              OF oDlg PIXEL SIZE 50,12                  ;
              FONT oFont                                ;
              ACTION oPrueba1:IrFecha( Date() )

    oBtn[  3]:cToolTip := ( "Data Selecionada Pelo Usurio: Hoje " )

    @  80,140 BUTTON oBtn[  4] PROMPT "&Ingls       "  ;
              OF oDlg PIXEL SIZE 50,12                  ;
              FONT oFont                                ;
              ACTION ( oPrueba1:nLanguage := 7,         ;
                       oPrueba1:Language(),             ;
                       oPrueba1:Paint() )

    oBtn[  4]:cToolTip := ( "Lingua Selecionada Pelo Usurio: Ingls " )

    @  95,140 BUTTON oBtn[  5] PROMPT "&Espanhol     "  ;
              OF oDlg PIXEL SIZE 50,12                  ;
              FONT oFont                                ;
              ACTION ( oPrueba1:nLanguage := 5, ;
                       oPrueba1:Language(),     ;
                       oPrueba1:Paint() )

    oBtn[  5]:cToolTip := ( "Lingua Selecionada Pelo Usurio: Espanhol " )

    @ 110,140 BUTTON oBtn[  6] PROMPT "&Nova Cor     "  ;
              OF oDlg PIXEL SIZE 50,12                  ;
              FONT oFont ;
              ACTION ( oPrueba1:aColorCuerpo := aColorCuerpo, ;
                       oPrueba1:aColorTitulo := aColorTitulo, ;
                       oPrueba1:aColorBoton  := aColorBoton , ;
                       oPrueba1:RestaurarColor(),             ;
                       oPrueba1:Paint() )

    oBtn[  6]:cToolTip := ( "Cores Selecionada Pelo Usurio: Escolha " )

    @ 125,140 BUTTON oBtn[  7] PROMPT "&Pintar Dia 15"       ;
              OF oDlg PIXEL SIZE 50,12                       ;
              FONT oFont                                     ;
              ACTION ( oPrueba1:ColorDia( 15, aClrFestivo ), ;
                       oPrueba1:Paint() )

    oBtn[  7]:cToolTip := ( "Colorir o Dia 15 do Ms Corrente" )

    @ 140,140 BUTTON oBtn[  8] PROMPT "&Saida       "   ;
              OF oDlg PIXEL SIZE 50,12                  ;
              FONT oFont                                ;
              ACTION( oDlg:End() ) CANCEL

    oBtn[  8]:cToolTip := "Saida - Exit - Cancelar"

    //SET FONT OF oBtn[  8]    TO oFont

    ACTIVATE DIALOG oDlg CENTERED

    EndDialog()

    oBrush:End()

    // Se sacan los recursos de memoria.
    RELEASE FONT oFont
    RELEASE FONT oFont3
    RELEASE ALL

Return Nil

// Esta funcion es una alternativa al pintado de los festivos..
STATIC FUNCTION FijarFestivos( oCalendario )

    LOCAL aClrFestivo := { Rgb( 177, 218, 173),;   //Color borde superior
                           Rgb( 121, 192, 114),;   //Color relleno
                           Rgb(  70, 141,  50),;   //Color borde inferior
                           Rgb(   0,   0,   0) }   //color texto....

    DO CASE
        CASE oCalendario:nMesNumero == 1
             oCalendario:ColorDia( 1, aClrFestivo )

        CASE oCalendario:nMesNumero == 2


        CASE oCalendario:nMesNumero == 3


        CASE oCalendario:nMesNumero == 4
             oCalendario:ColorDia(18, aClrFestivo )
             oCalendario:ColorDia(19, aClrFestivo )

        CASE oCalendario:nMesNumero == 5
             oCalendario:ColorDia( 1, aClrFestivo )
             oCalendario:ColorDia(21, aClrFestivo )

        CASE oCalendario:nMesNumero == 6
             oCalendario:ColorDia(16, aClrFestivo )

        CASE oCalendario:nMesNumero == 7

        CASE oCalendario:nMesNumero == 8
             oCalendario:ColorDia(15, aClrFestivo )

        CASE oCalendario:nMesNumero == 9
             oCalendario:ColorDia(18, aClrFestivo )
             oCalendario:ColorDia(19, aClrFestivo )

        CASE oCalendario:nMesNumero == 10

        CASE oCalendario:nMesNumero == 11
             oCalendario:ColorDia( 1, aClrFestivo )

        CASE oCalendario:nMesNumero == 12
             oCalendario:ColorDia(25, aClrFestivo )

       ENDCASE

RETURN NIL

STATIC FUNCTION aComboTitulo()

    LOCAL aDeColores

    aDeColores :={ {Rgb(170,170, 80), Rgb(130,130, 65),Rgb(100,100, 50),      ;
                    Rgb( 205, 205, 155), Rgb( 205, 205, 155) },               ;
                   {Rgb( 55,170,170), Rgb( 40,120,120),Rgb( 40,110,110),      ;
                    Rgb( 205, 205, 155), Rgb( 205, 205, 155) },               ;
                   {Rgb( 60,160, 60), Rgb( 50,125, 50),Rgb( 40,110, 40),      ;
                    Rgb( 205, 205, 155), Rgb( 205, 205, 155) },               ;
                   {Rgb(190, 60,190), Rgb(150, 50,150),Rgb(110, 40,110),      ;
                    Rgb( 205, 205, 155), Rgb( 205, 205, 155) },               ;
                   {Rgb(190, 63, 63), Rgb(150, 50, 50),Rgb(110, 40, 40),      ;
                    Rgb( 205, 205, 155), Rgb( 205, 205, 155) },               ;
                   {Rgb(125,125,125), Rgb(100,100,100),Rgb( 75, 75, 75),      ;
                    Rgb( 205, 205, 155), Rgb( 205, 205, 155) } }

RETURN aDeColores

STATIC FUNCTION aComboCuerpo()

    LOCAL aDeColores

    aDeColores :={ {Rgb(235,235,210), Rgb(205,205,155),Rgb(150,150, 75),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) },               ;
                   {Rgb(205,240,240), Rgb(145,220,220),Rgb( 55,170,170),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) },               ;
                   {Rgb(205,240,205), Rgb(175,210,175),Rgb( 55,170, 55),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) },               ;
                   {Rgb(240,205,240), Rgb(220,145,220),Rgb(170, 55,170),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) },               ;
                   {Rgb(240,205,205), Rgb(230,180,180),Rgb(210,120,120),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) },               ;
                   {Rgb(220,220,220), Rgb(180,180,180),Rgb(110,110,110),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) } }

RETURN aDeColores

STATIC FUNCTION aComboDomingo()

    LOCAL aDeColores

    aDeColores :={ {Rgb(255,255,255), Rgb(220,220,220),Rgb(128,128,128),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) },               ;
                   {Rgb(255,255,255), Rgb(203,238,238),Rgb( 65,192,192),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) },               ;
                   {Rgb(255,255,255), Rgb(203,238,203),Rgb( 65,192, 65),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) },               ;
                   {Rgb(255,255,255), Rgb(238,203,238),Rgb(192, 65,192),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) },               ;
                   {Rgb(255,255,255), Rgb(238,203,203),Rgb(192, 65, 65),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) },               ;
                   {Rgb(255,255,255), Rgb(220,220,220),Rgb(128,128,128),      ;
                    Rgb(   0,   0,   0), Rgb( 130, 130,  65) } }

RETURN aDeColores

// Datos que devuelve el calendario.
*  dFechaControl , la fecha seleccionado, formato fecha.

*  nMesNumero    , el numero del mes    , formato numero
*  cMesNumero    , el numero del mes    , formato caracter
*  cMesPalabra   , el nombre del mes

*  nDiaSemana    , el numero del dia de la semana formato numero
*  cDiaSemana    , el numero del dia de la semana formato caracter
*  cDiaPalabra   , el nombre del dia de la semana
*  nDiaMes       , el dia del mes formato numero
*  cDiaMes       , el dia del mes formato caracter
*  cDiaMesPalabra, el dia del mes en palabras.

*  nAno          , el numero del ao formato numero
*  cAno          , el numero del ao formato caracter
*  cAnoPalabra   , el numero del ao en palabras.

* array con formatos de fecha.
*  aFecha[ 1]    , XX de enero del XXXX
*  aFecha[ 2]    , Domingo,XX de Septiembre de XXXX      

*Se encuentra habilitado el boton derecho del mouse con otras
*opciones, mientras veo donde coloco los botones...

*METODOS
* CambiarMes( nMes)
* MesSiguinte() INLINE ::CambiarMes( +1)
* MesAnterior() INLINE ::CambiarMes( -1)
* AnoSiguinte() INLINE ::CambiarMes( 12)
* AnoAnterior() INLINE ::CambiarMes(-12)

//-> FIM DO PROGRAMA
